#include "sharedm.h"

class MyFunkyClass {
	public:
		MyFunkyClass() {
			data = new int ;
			}
		void Update() { (*data)++ ; }
		void Draw ()  { printf("%d\n",*data); } 
	int *data ;
};

float *value ;
MyFunkyClass * classVal ;

void ForkIt(void) {
	if( fork() == 0 ){
		while ( 1 ) {
			// do this if Update will new or delete
			//   SharedMemArena::on();
			classVal->Update();
			sginap(1);
			//   SharedMemArena::off();
		}
	}
}

main(){
	SharedMemArena memory(2000000); // make instance so that it gets destructed at the end of the program 

	SharedMemArena::on();
	value = new float [100];	// this is in shared 
	classVal = new MyFunkyClass;   
	*(classVal->data) = 17 ; // this will be in shared mem;
	SharedMemArena::off();

	ForkIt(); // one proc updates 

	for (int i=0; i<200; i++) { // other proc draws 
		classVal->Draw();
		}

	SharedMemArena::on();
	delete value;
	delete classVal ;
	SharedMemArena::off();
	return 0;
}
